using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Exferia_Hermes._1_Datos
{
    public class HRM_Agencias_TarifasCabecera_Datos
    {
        #region Obtener
        public List<long> Obtener_Listado_idAgencia_PorTdTarifaCabecera(long _lng_idTarifaCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<long> lst_idAgencia = new List<long>();
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .........................................................
                string str_SQL =
                         " SELECT " +
                             nameof(HRM_Agencias_TarifasCabecera) + "." + nameof(HRM_Agencias_TarifasCabecera.idAgencia) +
                         " FROM " + nameof(HRM_Agencias_TarifasCabecera) +
                         " WHERE " + nameof(HRM_Agencias_TarifasCabecera.idTarifaCabecera) + "=@idTarifaCabecera ";
                // .....................................................................

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTarifaCabecera",  _lng_idTarifaCabecera)
                };

                //Rellenar el Modelo
                lst_idAgencia = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_Agencias_TarifasCabecera_Datos) + "/" + nameof(Obtener_Listado_idAgencia_PorTdTarifaCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_idAgencia;
        }
        #endregion

        #region MODELOS

        #region Modelo Listado
        private List<HRM_Agencias_TarifasCabecera> g_lst_HRM_Agencias_TarifasCabecera = null;
        public List<HRM_Agencias_TarifasCabecera> Obtener_ModeloListado_Por_IdAgencia(long _lng_idAgencia,
                                                                                        bool _bol_Cargar_TarifasCabecera)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(HRM_Agencias_TarifasCabecera) + "." + nameof(HRM_Agencias_TarifasCabecera.idAgencia) + "=@idAgencia";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idAgencia",  _lng_idAgencia)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_TarifasCabecera);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_Agencias_TarifasCabecera_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdAgencia), true);
            }

            return g_lst_HRM_Agencias_TarifasCabecera;
        }

        #region Ejecutar consulta

        private List<HRM_TarifasCabecera> g_lst_HRM_TarifasCabecera = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros,
                                              bool _bol_Cargar_TarifasCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HRM_Agencias_TarifasCabecera = obj_Exferia_Entities.Database.SqlQuery<HRM_Agencias_TarifasCabecera>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar Tablas Relacionadas
                if (g_lst_HRM_Agencias_TarifasCabecera != null && g_lst_HRM_Agencias_TarifasCabecera.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_TarifasCabecera)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //HRM_TarifasCabecera #############################################
                        if (_bol_Cargar_TarifasCabecera)
                        {
                            ThreadStart obj_ThreadStart_TARIFASCABECERA = new ThreadStart(Obtener_TarifasCabecera_Modelo_Listado);
                            Thread obj_Thread_TARIFASCABECERA = new Thread(obj_ThreadStart_TARIFASCABECERA);
                            obj_Thread_TARIFASCABECERA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (HRM_Agencias_TarifasCabecera mdl_HRM_Agencias_TarifasCabecera in g_lst_HRM_Agencias_TarifasCabecera)
                        {
                            //HRM_TarifasCabecera #############################################
                            if (_bol_Cargar_TarifasCabecera &&
                                g_lst_HRM_TarifasCabecera != null &&
                                g_lst_HRM_TarifasCabecera.Count > 0)
                            {
                                mdl_HRM_Agencias_TarifasCabecera.HRM_TarifasCabecera = g_lst_HRM_TarifasCabecera.Where(m => m.id == mdl_HRM_Agencias_TarifasCabecera.idTarifaCabecera).FirstOrDefault();
                            }
                        }
                        #endregion

                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_Agencias_TarifasCabecera_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #region Tablas Relacionadas
        private void Obtener_TarifasCabecera_Modelo_Listado()
        {
            try
            {
                HRM_TarifasCabecera_Datos obj_HRM_TarifasCabecera_Datos = new HRM_TarifasCabecera_Datos();
                g_lst_HRM_TarifasCabecera=obj_HRM_TarifasCabecera_Datos.Obtener_ModeloListado_Por_IdsAgencia(g_lst_HRM_Agencias_TarifasCabecera.Select(m => m.idAgencia).ToList(),true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                     nameof(HRM_Agencias_TarifasCabecera.idAgencia) + " , " +
                     nameof(HRM_Agencias_TarifasCabecera.idTarifaCabecera) + " , " +
                     nameof(HRM_Agencias_TarifasCabecera.observaciones) +
                " FROM " + nameof(HRM_Agencias_TarifasCabecera);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(long _lng_idAgencia, List<long> _lst_idTarifaCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.ProxyCreationEnabled = true;

                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(HRM_Agencias_TarifasCabecera) + " WHERE " + nameof(HRM_Agencias_TarifasCabecera.idAgencia) + "=" + _lng_idAgencia;
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (_lst_idTarifaCabecera != null && _lst_idTarifaCabecera.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (long lng_id in _lst_idTarifaCabecera)
                    {
                        str_SQL_Insertar += " INSERT INTO " + nameof(HRM_Agencias_TarifasCabecera) + " (" + nameof(HRM_Agencias_TarifasCabecera.idAgencia) + "," + nameof(HRM_Agencias_TarifasCabecera.idTarifaCabecera) + "," + nameof(HRM_Agencias_TarifasCabecera.observaciones) + ") values (" + _lng_idAgencia + "," + lng_id + ",'')";
                    }

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_Agencias_TarifasCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
